
/**
 * You need to enter your affiliate ID - you can get this from your affiliate panel from
 * http://www.qualityunit.com/affiliate/affiliates
 */
var affiliateId = ''; // MANDATORY

/**
 * You can set channelId assigned to you by Quality Unit. If you do not know your channelId,
 * leave the line below as it is.
 */
var channelId = ''; // OPTIONAL

/**
 * After successful signup, user is redirected to newly created account. Here you can choose
 * whether they should be redirected in signup window or to completely new window.
 * Possible values: true, false
 */
var redirectAfterSignupToNewWindow = false; // MANDATORY

/**
 * Initial account language - this language will be set as default after installation
 * Some possible values:
 *  en-US - English
 *  sk - Slovak
 *  cs - Czech
 */
var languageCode = 'en-US'; // MANDATORY

/**
 * Here you can translate all messages related to script execution.
 */
var msg = {
    installing: "Installing...",
    launching: "Launching...",
    coffee: "Coffee time!",
    redirecting: "Redirecting...",

    createButtonText: "Start now",
    createButtonTextWorking: "Creating...",

    validatingEmail: "Validating email...",
    emailOk: "Email OK.",
    emailInvalid: "Whoops, enter a valid email",
    emailEmpty: "Your email goes here",

    validatingDomain: "Validating domain...",
    domainOk: "Domain is valid",
    domainProblem: "Problem with domain. Contact our support, please.",
    domainEmpty: "Choose a unique name",

    nameEmpty: "Fill in your name"
};

/********************************************************
 * Do not change anything under this line
 ********************************************************/
var variationId = '3513230f';
var productid = "b229622b";
var subscriptionsApi = "https://crm.qualityunit.com/api/v3/subscriptions/";

var valid_domain = false;
var valid_email = false;
var valid_name = false;
var token = false;
var timer;
var ccnotrequired = true;
var stripesAnim;
var previous_button_text;
var sending = false;


function stripesAnimate() {
    animating();
    stripesAnim = setInterval(animating, 2500);
}

function animating() {
    $('.progress-stripes').animate({
        marginLeft: "-=30px"
    }, 2500, "linear").append('/');
}

var setProgress = function(progress) {
    $('.progress-bar').width(progress + "%");
    if(progress <= 33) {
        $('.loader-label').text(msg.installing);
    } else if(progress <= 66) {
        $('.loader-label').text(msg.launching);
    } else {
        $('.loader-label').text(msg.coffee);
    }
    $('.percentage').text(progress + "%");
};

function sendApiRequest(options) {
    options.dataType = "json";

    if(options.data) {
        options.data = JSON.stringify(options.data);
    }

    if(options.params) {
        options.url += "?" + $.param(options.params);
        options.params = undefined;
    }

    $.ajax(options);
}

function parseError(response, def) {
    if (response.status == 500) {
        return def;
    }
    try {
        return JSON.parse(response.responseText).message;
    } catch (ignore) {
    }
    return def;
}

var loading = function(subscription_id) {
    sendApiRequest({
        type: "GET",
        url: subscriptionsApi + subscription_id + "/install_progress",
        success: function(data) {
            console.log(data);
            if (data.account_status == undefined || data.progress == undefined) {
                setTimeout(function () {
                    loading(subscription_id);
                }, 700);
                return;
            }
            if (data.account_status == 'I') {
                setProgress(data.progress);
                setTimeout(function() {
                    loading(subscription_id);
                }, 700);
            } else {
                $('.progress-bar').width("100%");
                $('.loader-label').text(msg.redirecting);
                $('.percentage').text("100%");
                var target = redirectAfterSignupToNewWindow ? 'target="_blank"' : '';
                var redirectForm = '<form ' + target + ' method="POST" action="' + data.login_url +'">'
                    + '<input type="hidden" name="action" value="login">'
                    + '<input type="hidden" name="AuthToken" value="' + data.login_token + '">'
                    + '<input type="hidden" name="l" value="' + languageCode + '"></form>';
                $(redirectForm).appendTo('body').submit();
            }
        },
        error: function (data) {
            console.log(data);
        }
    });
};

var hideSingupForm = function(subscription_id) {
    $('#signup').hide(300);
    $('#loader').show(300);
    stripesAnimate();
    loading(subscription_id);
};

var doSignUpRequest = function() {
    var papVisitorId = $.cookie('PAPVisitorId') != 'undefined' ? $.cookie('PAPVisitorId') : '';
    var data = {
        variation_id: variationId,
        subdomain: $('#domainFieldinnerWidget').val(),
        language: languageCode,
        pap_visitor_id: papVisitorId,
        source_id: channelId,
        customer: {
            name: $('#nameFieldinnerWidget').val(),
            email: $('#mailFieldmain input').val(),
            phone: ' '
        }
    };

    sendApiRequest({
        url: subscriptionsApi,
        type: "POST",
        data: data,
        success: function(subscription) {
            console.log(subscription);
            hideSingupForm(subscription.id);

            /* PAP tracking */

            if (typeof PostAffTracker != "undefined") {
                PostAffTracker.setAccountId('default1');
                var sale = PostAffTracker.createAction('LATrial');
                sale.setTotalCost('1');
                sale.setOrderID(subscription.id);
                sale.setProductID('');
                sale.setChannelID(channelId);
                sale.setAffiliateID(affiliateId);
                sale.setData1(subscription.customer_email);
                sale.setData3('api_qu_signup');
                sale.setData4(subscription.domain);
                sale.setCampaignID('cc052a4f');
                PostAffTracker.register();
            }

        },
        error: function (data) {
            console.log(data);
            $('#createButtonmain').removeAttr("disabled");
            $('#createButtontextSpan').html(previous_button_text);
            sending = false;
        }
    });
};

$.fn.removeAll = function() {
    this.removeClass("FField-Error");
    this.removeClass("FField-Waiting");
    this.removeClass("FField-Valid");
    $(this).find('.FField-Message').html("");
};

$.fn.addError = function(message) {
    this.removeAll();
    this.addClass("FField-Error");
    $(this).find('.FField-Message').html(message);
};

$.fn.addValidating = function(message) {
    this.removeAll();
    this.addClass("FField-Waiting");
    $(this).find('.FField-Message').html(message);
};

$.fn.addOk = function(message) {
    this.removeAll();
    this.addClass("FField-Valid");
    $(this).find('.FField-Message').html(message);
};

var sendForm = function() {
    if ((valid_domain)&&(valid_email)&&(valid_name)&&(ccnotrequired||token)) {
        doSignUpRequest();
    } else {
        if(!$('#mailFieldmain input').val()) {
            $('#mailFieldmain').addError(msg.emailEmpty);
        }
        if(!$('#nameFieldmain input').val()) {
            $('#nameFieldmain').addError(msg.nameEmpty);
        }
        if(!$('#domainFieldmain input').val()) {
            $('#domainFieldmain').addError(msg.domainEmpty);
        }
        $('#createButtonmain').removeAttr("disabled");
        $('#createButtontextSpan').html(previous_button_text);
        sending = false;
    }
};
var validateEmail = function() {
    valid_email = false;
    var mailRegex = /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/i;

    var mail_field = $('#mailFieldmain');

    if (mailRegex.test(mail_field.find('input').val())) {
        valid_email = true;
        mail_field.addOk(msg.emailOk);
    } else {
        mail_field.addError(msg.emailInvalid);
    }
};
var validateDomain = function() {
    var subdomainField = $('#domainFieldmain');
    var subdomain = subdomainField.find('input').val();
    if (subdomain == '') {
        return true;
    }
    valid_domain = false;
    subdomainField.addValidating(msg.validatingDomain);
    sendApiRequest({
        url: subscriptionsApi + "_check_domain",
        method: "POST",
        params: {
            productId: productid,
            subdomain: subdomain
        },
        success: function(data) {
            console.log(data);
            subdomainField.removeAll();
            subdomainField.addOk(msg.domainOk);
            valid_domain = true;
        },
        error: function (data) {
            subdomainField.addError(parseError(data), "Validation error occurred");
            console.log(data);
        },
    })
};
jQuery(function($) {
    $('#domainFieldmain input').alphanum({
        allow              : '-0123456789',
        disallow           : '',
        allowSpace         : false,
        allowNumeric       : true,
        allowUpper         : false,
        allowLower         : true,
        allowCaseless      : false,
        allowLatin         : true,
        allowOtherCharSets : false,
    });
    $('#domainFieldmain').on('keyup', function() {
        clearInterval(timer);
        timer = setTimeout(function() {
            validateDomain();
        }, 500);
    });
    /* in case of initial empty input and focusout */
    $('#domainFieldmain').focusout(function() {
        if(!$('#domainFieldmain input').val()) {
            $('#domainFieldmain').addError(msg.domainEmpty);
        }
    });
    /* in case of autocomplete */
    $('#domainFieldmain').on('change', function() {
        if(!$('#domainFieldmain input').val()) {
            $('#domainFieldmain').addError(msg.domainEmpty);
        }
        else {
            validateDomain()
        }
    });
    $("#mailFieldmain").on('keyup', function() {
        $('#mailFieldmain').removeAll();
        clearInterval(timer);
        timer = setTimeout(function() {
            validateEmail();
        }, 500);
    });
    $('#mailFieldmain').focusout(function() {
        $('#mailFieldmain').removeAll();
        if(!$('#mailFieldmain input').val()) {
            $('#mailFieldmain').addError(msg.emailEmpty);
        } else {
            validateEmail();
        }
    });
    $('#mailFieldmain').on('change', function() {
        $('#mailFieldmain').removeAll();
        if(!$('#mailFieldmain input').val()) {
            $('#mailFieldmain').addError(msg.emailEmpty);
        } else {
            validateEmail();
        }
    });
    $('#nameFieldmain').focusout(function() {
        if(!$('#nameFieldmain input').val()) {
            valid_name = false;
            $('#nameFieldmain').addError(msg.nameEmpty);
        } else {
            valid_name = true;
            $('#nameFieldmain').addOk("");
        }
    });
    $('#nameFieldmain').on('change', function() {
        if(!$('#nameFieldmain input').val()) {
            valid_name = false;
            $('#nameFieldmain').addError(msg.nameEmpty);
        } else {
            valid_name = true;
            $('#nameFieldmain').addOk("");
        }
    });
    $('#createButtonmain').click(function() {
        if(!sending) {
            sending = true;
            $(this).attr("disabled", "disabled");
            previous_button_text = $('#createButtontextSpan').html();
            $('#createButtontextSpan').html(msg.createButtonTextWorking);
            sendForm();
        }
        return false;
    });
});
